from guicore.screencallmanager import pg

from utils import fonts
from utils.utilfuncs import wc


def fitFont(font, s, FitLine):
	if not FitLine:
		return s
	s2 = s
	starg = fonts.fonts.Font(s2, font).get_linesize()
	while starg > s:
		s2 = s / starg * s2
		starg = fonts.fonts.Font(s2, font).get_linesize()
	return s2


def CreateTextBlock(textlines, fontsizes, color, center, font=fonts.monofont, FitLine=False, MaxWidth=1000000):
	lines = textlines[:] if isinstance(textlines, list) else [textlines]
	sizes = fontsizes[:] if isinstance(fontsizes, list) else [fontsizes]
	h = 0
	w = 0
	t = len(sizes)
	if len(lines) > t:
		for i in range(len(lines) - t):
			sizes.append(sizes[-1])
	rl = []
	for line, s in zip(lines, sizes):
		for trys in [s, int(.75 * s), int(.625 * s)]:
			usesz = fitFont(font, trys, FitLine)
			line = fonts.fonts.Font(usesz, font).render(line, 0, wc(color))
			if line.get_width() < MaxWidth:
				break
		if line.get_width() > MaxWidth:
			usesz = fitFont(font, s // 2, FitLine)
			breaks = [i for i, ltr in enumerate(line) if ltr == ' '] + [len(line) - 1]
			for indx, val in enumerate(breaks):
				if fonts.fonts.Font(usesz, font).size(line[:breaks[indx]])[0] > MaxWidth:
					break
			# noinspection PyUnboundLocalVariable
			lleft = line[:breaks[indx - 1]]
			lright = '  ' + line[breaks[indx - 1]:]
			usesz = fitFont(font, s // 2, FitLine)
			line1 = fonts.fonts.Font(usesz, font).render(lleft, 0, wc(color))
			line2 = fonts.fonts.Font(usesz, font).render(lright, 0, wc(color))
			rl.append(line1)
			rl.append(line2)
			h += (rl[-1].get_height() + rl[-2].get_height())
			w = max(w, rl[-1].get_width(), rl[-2].get_width())
		else:
			rl.append(line)
			h += rl[-1].get_height()
			w = max(w, rl[-1].get_width())
	blk = pg.Surface((w, h))
	blk.set_colorkey(wc('black'))
	v = 0
	for line in rl:
		if center:
			blk.blit(line, ((w - line.get_width()) / 2, v))
		else:
			blk.blit(line, (0, v))
		v += line.get_height()

	return blk, blk.get_height(), blk.get_width()
